



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Docker容器学习梳理 - 私有仓库Registry使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Docker容器学习梳理 - 私有仓库Registry使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:47:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>但有时候使用Docker Hub这样的公共仓库可能不方便，这种情况下用户可以使用registry创建一个本地仓库供私人使用，这点跟Maven的管理类似。<br />使用私有仓库有许多优点：</p>
<div>
<pre class="prettyprint linenums">1）节省网络带宽，针对于每个镜像不用每个人都去中央仓库上面去下载，只需要从私有仓库中下载即可；<br />
2）提供镜像资源利用，针对于公司内部使用的镜像，推送到本地的私有仓库中，以供公司内部相关人员使用。</pre>
</div>
<p>目前Docker Registry已经升级到了v2，最新版的Docker已不再支持v1。Registry v2使用Go语言编写，在性能和安全性上做了很多优化，重新设计了镜像的存储格式。如果需要安装registry v2，只需下载registry:2.2即可。Docker官方提供的工具docker-registry可以用于构建私有的镜像仓库。废话不多说了，下面记录下Docker私有仓库构建的过程：</p>
<div>
<pre class="prettyprint linenums">选择一台服务器（内外网地址：192.168.1.23）作为注册服务器，用于搭建私有仓库。（该机器要安装了Docker环境）<br />
1）从Docker官方仓库里下载registry镜像<br />
[root@localhost ~]# docker pull registry:2.2<br />
----------------------------------------------------------------<br />
或者：<br />
[root@localhost ~]# docker pull registry<br />
[root@localhost ~]# docker pull registry:2.1.1<br />
----------------------------------------------------------------<br />
下载完之后，可以通过该镜像启动一个容器<br />
[root@localhost ~]# docker images<br />
REPOSITORY           TAG                 IMAGE ID            CREATED             SIZE<br />
tomcat7              latest              97c6a43dd69c        12 minutes ago      562.3 MB<br />
docker.io/registry   2.2                 ad379b517aa6        14 months ago       224.5 MB

默认情况下，会将私有仓库存放于容器内的/tmp/registry目录下，这样如果容器被删除，则存放于容器中的镜像也会丢失。<br />
所以一般情况下会指定本地一个目录挂载到容器内的/tmp/registry下，如下：<br />
[root@localhost ~]# docker run -d --name=my_registry -p 5000:5000 -v /opt/data/registry:/tmp/registry docker.io/registry:2.2<br />
9fe45329bda17f61da04e6e8d2faf124fb22665a25270421bb8979a419809446

[root@localhost ~]# docker ps<br />
CONTAINER ID        IMAGE                    COMMAND                  CREATED              STATUS              PORTS                    NAMES<br />
d8e98b1068cd        docker.io/registry:2.2   "/bin/registry /etc/d"   About a minute ago   Up About a minute   0.0.0.0:5000-&gt;5000/tcp   my_registry

由上可以看到，已经启动了一个容器，地址为：192.168.1.23:5000。

2）测试<br />
接下来可以把一个本地镜像push（如下面的tomcat7镜像）到私有仓库中。<br />
[root@localhost ~]# docker images<br />
REPOSITORY           TAG                 IMAGE ID            CREATED             SIZE<br />
tomcat7              latest              97c6a43dd69c        18 minutes ago      562.3 MB<br />
docker.io/registry   2.2                 ad379b517aa6        14 months ago       224.5 MB

修改一下该镜像的tag标识。<br />
[root@localhost ~]# docker tag tomcat7 192.168.1.23:5000/tomcat7

[root@localhost ~]# docker tag tomcat7 192.168.1.23:5000/tomcat7       //修改了tag后的镜像若要删除，docker rmi后面不能用镜像ID了，需要用docker rmi 192.168.1.23:5000/tomcat7:latest<br />
REPOSITORY                  TAG                 IMAGE ID            CREATED             SIZE<br />
192.168.1.23:5000/tomcat7   latest              97c6a43dd69c        18 minutes ago      562.3 MB<br />
tomcat7                     latest              97c6a43dd69c        18 minutes ago      562.3 MB<br />
docker.io/registry          2.2                 ad379b517aa6        14 months ago       224.5 MB

接下来把上面修改tag后的镜像上传到私有仓库。<br />
[root@localhost ~]# docker push 192.168.1.23:5000/tomcat7<br />
The push refers to a repository [192.168.1.23:5000/tomcat7]<br />
unable to ping registry endpoint https://192.168.1.23:5000/v0/<br />
v2 ping attempt failed with error: Get https://192.168.1.23:5000/v2/: http: server gave HTTP response to HTTPS client<br />
v1 ping attempt failed with error: Get https://192.168.1.23:5000/v1/_ping: http: server gave HTTP response to HTTPS client

出现上面错误的原因分析：<br />
因为Docker从1.3.X之后，与docker registry交互默认使用的是https，然而此处搭建的私有仓库只提供http服务，所以当与私有仓库交互时就会报上面的错误。<br />
为了解决这个问题需要在启动docker server时增加启动参数为默认使用http访问。<br />
需要在docker的配置文件/etc/sysconfig/docker （ubuntu系统中的docker配置文件时/etc/default/docker ）添加参数&ldquo;--insecure-registry=192.168.1.23:5000&rdquo;。<br />
-----------------------------------------------------------------------------------------------------------<br />
温馨提示：<br />
这个是在客户机的docker配置文件里添加的(即上传镜像到私有仓库里或从私有仓库下载镜像的客户机)。<br />
比如说在A机器上将它的镜像上传到192.168.1.23的私有仓库上或从该私有仓库下载镜像，那么就在A机器的本地docker配置文件中添加。<br />
我这里测试用的是同一台机器(centos7)，即将注册机192.168.1.23本机的镜像上传到它的仓库内。     [如果是centos6系统，就在other_args选项后面添加。other_args="--graph=/docker --insecure-registry=192.168.1.234:5000"]<br />
-----------------------------------------------------------------------------------------------------------<br />
[root@localhost ~]# vim /etc/sysconfig/docker<br />
.......<br />
OPTIONS='--selinux-enabled --log-driver=journald'<br />
改为<br />
OPTIONS='--selinux-enabled --log-driver=journald --insecure-registry=192.168.1.23:5000'

[root@localhost ~]# service docker restart

由于docker服务重启后，所有容器都会被关闭。所以需要在docker重启后再次启动容器<br />
[root@localhost ~]# docker start my_registry<br />
my_registry<br />
[root@localhost ~]# docker ps<br />
CONTAINER ID        IMAGE                    COMMAND                  CREATED              STATUS              PORTS                    NAMES<br />
d8e98b1068cd        docker.io/registry:2.2   "/bin/registry /etc/d"   About a minute ago   Up About a minute   0.0.0.0:5000-&gt;5000/tcp   my_registry

再次提交到私有仓库<br />
[root@localhost ~]# docker push 192.168.1.23:5000/tomcat7<br />
The push refers to a repository [192.168.1.23:5000/tomcat7]<br />
c6d7ce9e90d7: Pushed<br />
34e7b85d83e4: Pushed<br />
latest: digest: sha256:5fdcbaf254cb44dd26645f606cccea8de76118baff03485e40853c691a15956d size: 720

上面命令执行无误后，就表示镜像已经push到私有仓库中去了。<br />
查看私有仓库里的镜像（一定要保证下面能查看到仓库里有镜像！如果仓库里没有镜像，那么客户端机器就无法从该私有仓库下载镜像了）<br />
[root@localhost ~]# curl -XGET http://192.168.1.23:5000/v2/_catalog    //即该私有仓库里有tomcat7镜像<br />
{"repositories":["tomcat7"]}<br />
[root@localhost ~]# curl -XGET http://192.168.1.23:5000/v2/tomcat7/tags/list<br />
{"name":"tomcat7","tags":["latest"]}<br />
或者浏览器里访问（103.110.186.23是注册机的外网ip，iptables防火墙内开放5000端口访问）：<br />
http://103.110.186.23:5000/v2/_catalog<br />
http://103.110.186.23:5000/v2/tomcat7/tags/list

现在可以将本地的tomcat7和192.168.1.23:5000/tomcat7镜像都删除，然后从私有仓库中下载<br />
[root@localhost ~]# docker rmi tomcat7<br />
[root@localhost ~]# docker rmi 192.168.1.23:5000/tomcat7

[root@localhost ~]# docker pull 192.168.1.23:5000/tomcat7<br />
[root@localhost ~]# docker images<br />
REPOSITORY                  TAG                 IMAGE ID            CREATED             SIZE<br />
192.168.1.23:5000/tomcat7   latest              5hc8a2ip413w        3 days ago          562.3 MB

-----------------------------------------------------------------------------<br />
这样，也就可以在同一局域网内的其他机器上，从该私有仓库中pull下来该镜像。<br />
比如在192.168.1.17服务器上拉取该私有仓库的tomcat镜像进行容器创建（注意，要在该机器的/etc/sysconfig/docker配置文件里添加--insecure-registry=192.168.1.23:5000参数）<br />
[root@linux-node2 ~]# docker pull 192.168.1.23:5000/tomcat7

[root@linux-node2 ~]# docker images<br />
REPOSITORY                  TAG                 IMAGE ID            CREATED             SIZE<br />
192.168.1.23:5000/tomcat7   latest              2ec9e2eb978a        3 days ago          562.3 MB

这样就搭建了Docker私有仓库，上面搭建的仓库是不需要认证的，我们可以结合nginx和https实现认证和加密功能。</pre>
</div>
<p><strong>注意查看镜像方法</strong>（docker pull registry:2.1.1）:</p>
<div>
<pre class="prettyprint linenums"># curl -XGET http://registry_ip:5000/v2/_catalog<br />
# curl -XGET http://registry_ip:5000/v2/image_name/tags/list</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxevmv8.html">linux环境下安装jdk</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnr2439.html">第十一章、认识与学习BASH</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw7wo38.html">在Delphi中如何控制其它应用程序窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvlzzyq.html">查看MySQL数据库的默认编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kv7g09.html">sqlalchemy 映射的小例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jnve8.html">LBPL--基于Asp&period;net、 quartz&period;net 快速开发定时服务的插件化项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jedyo8.html">自定义TabBar之理解hittest</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv221jz9.html">使用tcpdump探测TCP&sol;IP三次握手</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw5zmz9.html">Django--权限信息操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvnxxr8.html">《从Lucene到Elasticsearch：全文检索实战》学习笔记四</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r2jm68.html">&lbrack;HAOI2017&rsqb;方案数&lbrack;组合计数、容斥、dp&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o177k5q.html">JavaScript中标识符的命名</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmno7w9.html">c&plus;&plus; 判断数组元素是否有负数&lpar;any&lowbar;of&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3m66eq.html">GOF23设计模式之解释器模式（interpreter）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pp25vq.html">【洛谷 P1390】 公约数的和 （欧拉函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy2001d9.html">js正则判断日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4k2je8.html">collections模块的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15d3p49.html">【Mysql优化】MySQL Profiling 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x1y1v9.html">设置IIS，使客户端访问服务器上的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d3ok48.html">2017&period;6&period;30 使用git新建项目、仓库并拉取、提交代码</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1rdxm48.html">【HANA系列】SAP HANA XS使用JavaScript&lpar;JS&rpar;调用存储过程&lpar;Procedures&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w61zzq.html">FUSE 文件系统 example部分 源码注释 &lpar;libfuse 2&period;9&period;9&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1x3gw9.html">Java设计模式之十三 ---- 观察者模式和空对象模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w6zlgq.html">浅析Java中的23种设计模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvlop28.html">EasyUI设置选中复选框</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j6lk0q.html">JQuery中&dollar;&period;cookie&lpar;&rpar;方法的使用&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o12z2lq.html">tomcat健康检查监控脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rdgd28.html">metamask源码学习-metamask-controller&period;js﻿</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1gj0e9.html">slf4j&plus;logback搭建超实用的日志管理模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwejyy8.html">Java 中数组的内存分配</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
